﻿package de.davidochmann.utilities.dogesture.events 
{
	/**
	 * @author dochmann
	 */

	import flash.events.Event;

	public class GestureEvent extends Event 
	{
		public static var MOVE_COMPLETE:String    = "MOVE_COMPLETE";
		public static var GESTURE_COMPLETE:String = "GESTURE_COMPLETE";
		
		private var mComplete:Boolean;
		private var mIndex:uint;
		private var mGesture:Array;
		
		
		
		public function GestureEvent(type:String,
									 pComplete:Boolean  = false,
									 pIndex:uint		= 	  0, 
									 pGesture:Array		=  null,
									 bubbles:Boolean    = false, 
									 cancelable:Boolean = false):void
		{
			setComplete(pComplete);
			setIndex(pIndex);
			setGetsture(pGesture);
			
			super(type, bubbles, cancelable);
		}
		
		
		
		/*
		 * PUBLIC FUNCTIONS
		 */
		
		override public function clone():Event
		{
			return new GestureEvent(type, mComplete, mIndex, mGesture);
		}

		override public function toString():String
		{
			return formatToString("ImageContainerEvent", "type", "pIndex", "pComplete", "pGesture");	
		}
		
		
		
		/*
		 * GETTER FUNCTIONS
		 */
		
		public function getComplete():Boolean
		{
			return mComplete;
		}

		public function getIndex():uint
		{
			return mIndex;
		}

		public function getGesture():Array
		{
			return mGesture;
		}



		/*
		 * SETTER FUNCTIONS
		 */

		public function setComplete(pComplete:Boolean):void
		{
			mComplete = pComplete;
		}

		public function setIndex(pIndex:uint):void
		{
			mIndex = pIndex;
		}

		public function setGetsture(pGesture:Array):void
		{
			mGesture = pGesture;
		}
	}
}
