﻿package de.davidochmann.utilities.dogesture.stack 
{
	/**
	 * @author dochmann
	 */
	 
	import de.davidochmann.utilities.dogesture.move.Move;

	public class Stack 
	{
		private var mList:Array;
		private var mActive:Move;
		private var mIndex:uint;
		private var mComplete:Boolean;
		
		
		
		public function Stack():void
		{
			initList();
			initIndex();
			initComplete();
			initActive();
		}
		
		
		
		/*
		 * PUBLIC FUNCTIONS
		 */

		public function list():Array
		{
			return mList;
		}

		public function active():Move
		{
			return mActive;
		}

		public function complete():Boolean
		{
			return mComplete;
		}

		public function index():uint
		{
			return mIndex;
		}

		public function add(pMove:Move):void
		{
			mList.push(pMove);
			initActive();
		}

		public function reset():void
		{
			initIndex();
			initActive();
			initComplete();
		}
		
		public function next():void
		{
			if(mIndex + 1 == mList.length)
			{
				mIndex++;
				mComplete = true;
				return;
			}
				
			mIndex++;
			mActive = mList[mIndex];
		}
	


		/*
		 * PRIVATE FUNCTIONS
		 */
		
		private function initList():void
		{
			mList = new Array();
		}
		
		private function initIndex():void
		{
			mIndex = 0;
		}
		
		public function initComplete():void
		{
			mComplete = false;
		}
		
		private function initActive():void
		{
			mActive = Move(mList[mIndex]);
		}
	}
}
